<?php if(!defined('PURECLIENT_PATH')){die('Direct access not permitted');}
require_once(PURECLIENT_PATH.'/libraries/guzzle.phar');
use Guzzle\Http\Client;
		
class Project {

	public function __construct() {
	}
	
	function get_projects($person_uuid) {
		global $wpdb;
		$options = get_option('pure_profiles_options');
		$host = $options['pure_profiles_host_settings'];
		$username = $options['pure_profiles_username_settings'];
		$password = $options['pure_profiles_password_settings'];

		/* get all projects */
		$client = new Client($host);		
		$request = $client->get('/ws/rest/projects?rendering=xml_long&associatedPersonUuids.uuid='.$person_uuid.'&window.size=500');
		$request->getCurlOptions()->set(CURLOPT_SSL_VERIFYHOST, false);
		$request->getCurlOptions()->set(CURLOPT_SSL_VERIFYPEER, false);
		$request->getCurlOptions()->set(CURLOPT_CERTINFO, false);
		$request->getCurlOptions()->set(CURLOPT_TIMEOUT, 120);

		$request->setAuth($username, $password);
		$response = $request->send();
		$xml = $response->xml();
		$namespaces = $xml->getNamespaces(true);
				
		$core = $xml->children($namespaces['core']);
			
		$retrieved = date("F j, Y, g:i a"); 
		
		for ($i=0; $i < $core->count; $i++) {
			$project = $core->result->content[$i]->children($namespaces['project']);
			$title = $project->title->children($namespaces['core']);
			$the_title = $title->localizedString;
			$project_attributes = $core->result->content[$i]->attributes();
			$uuid = (string)$project_attributes['uuid'];
			$start_finish_date = $project->startFinishDate->children($namespaces['extensions']);
			$start_date = ($start_finish_date->startDate) ? $start_finish_date->startDate : "";
			$finish_date = ($start_finish_date->endDate) ? $start_finish_date->endDate: "";
			$status_attributes = $project->status->attributes();
			$status_id = $status_attributes->id;
			$status = $project->status->children($namespaces['core']);
			$the_status = $status->term->localizedString;
			$type_classification_attributes = $project->typeClassification->attributes();
			$type_classification_id = $type_classification_attributes->id;
			$type_classification = $project->typeClassification->children($namespaces['core']);
			$the_type_classification = $type_classification->term->localizedString;
						
			/* insert project into table */
			$table_name = $wpdb->prefix . "pure_profiles_project";
			$rows_affected = $wpdb->insert( $table_name, array( 
				'uuid' => $uuid, 
				'title' => $the_title,
				'startdate' => $start_date,
				'finishdate' => $finish_date,
				'projectstatusid' => $status_id,
				'projectstatus' => $the_status,
				'typeclassificationid' => $type_classification_id,
				'typeclassification' => $the_type_classification,
				'retrieved' => $retrieved
			));
			
			$project_persons = $project->persons->children($namespaces['person']);
			$num_project_persons = $project_persons->count();
			
			for ($j=0; $j < $num_project_persons; $j++) {
				$person_attributes = $project_persons[$j]->person->attributes();
				$p_uuid = $person_attributes->uuid;
				$person_name = $project_persons[$j]->person->name->children($namespaces['core']);
				$first_name = $person_name->firstName;
				$last_name = $person_name->lastName;
				$call_name = $project_persons[$j]->person->callName->children($namespaces['core']);
				$call_name_first_name = $call_name->firstName;
							
				/* insert person into table */
				$table_name = $wpdb->prefix . "pure_profiles_project_person";
				$rows_affected = $wpdb->insert( $table_name, array( 
					'personuuid' => $p_uuid, 
					'projectuuid' => $uuid,
					'firstname' => $first_name,
					'lastname' => $last_name,
					'callname' => $call_name_first_name,
					'retrieved' => $retrieved
				));				

			}
			
			$project_organisations = $project->organisations->children($namespaces['organisation']);

		}
		
	}
	
}