<?php if(!defined('PURECLIENT_PATH')){die('Direct access not permitted');}

add_action( 'admin_menu', 'pure_profiles_menu' );

function pure_profiles_menu() {
	add_options_page( 'Pure Profiles', 'Pure Profiles', 'manage_options', 'pure_profiles', 'pure_profiles_options' );
}

function pure_profiles_options() {
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	$pure_profiles_options = array(
		'pure_profiles_host_settings'=> '', 
		'pure_profiles_username_settings' => '', 
		'pure_profiles_password_settings' =>'',
		'pure_profiles_person_ids_settings' => '',
		'pure_profiles_person_uuids_settings' => '',		
		'pure_profiles_cron_basehour_settings' => '0',
		'pure_profiles_cron_recurrence_settings' => 'daily',
		'pure_profiles_cron_dev_settings' => 'no',
		'pure_profiles_enable_styles_settings' =>'yes'
		);
	add_option('pure_profiles_options', $pure_profiles_options);
?>	
	<div class="wrap">
	<h2>Pure Profiles</h2>
	<form action="options.php" method="post">				
		<?php settings_fields('pure_profiles_options'); ?>
		<?php do_settings_sections('pure_profiles'); ?>
		<input name="cat_submit" type="submit" id="submit" class="button-primary" style="margin-top:30px;" value="Save Changes" />
		<p></p>
		<?php $options = get_option('pure_profiles_options'); ?>
	</form>	
	</div>
<?php						
}

add_action('admin_init', 'pure_profiles_admin_init');
function pure_profiles_admin_init(){
	register_setting( 'pure_profiles_options', 'pure_profiles_options', 'pure_profiles_options_validate' );
	add_settings_section('pure_profiles_connection', '', 'pure_profiles_connection_section_text', 'pure_profiles', 'pure_profiles_connection' );
	add_settings_field('pure_profiles_hostname', 'Hostname', 'pure_profiles_host_settings', 'pure_profiles', 'pure_profiles_connection' );
	add_settings_field('pure_profiles_username', 'Username', 'pure_profiles_username_settings', 'pure_profiles', 'pure_profiles_connection' );
	add_settings_field('pure_profiles_password', 'Password', 'pure_profiles_password_settings', 'pure_profiles', 'pure_profiles_connection' );
	add_settings_section('pure_profiles_parameters', '', 'pure_profiles_parameters_section_text', 'pure_profiles', 'pure_profiles_parameters');
	add_settings_field('pure_profiles_person_ids', 'Employee IDs', 'pure_profiles_person_ids_settings', 'pure_profiles', 'pure_profiles_parameters' );
	add_settings_field('pure_profiles_person_uuids', 'Pure Person UUIDs', 'pure_profiles_person_uuids_settings', 'pure_profiles', 'pure_profiles_parameters' );
	add_settings_section('pure_profiles_cron', '', 'pure_profiles_cron_section_text', 'pure_profiles', 'pure_profiles_cron' );
	add_settings_field('pure_profiles_cron_basehour', 'Base Hour', 'pure_profiles_cron_basehour_settings', 'pure_profiles', 'pure_profiles_cron' );
	add_settings_field('pure_profiles_cron_recurrence', 'Recurrence', 'pure_profiles_cron_recurrence_settings', 'pure_profiles', 'pure_profiles_cron' );
	add_settings_field('pure_profiles_cron_dev', 'Development Mode', 'pure_profiles_cron_dev_settings', 'pure_profiles', 'pure_profiles_cron' );
	add_settings_section('pure_profiles_appearance', '', 'pure_profiles_appearance_section_text', 'pure_profiles', 'pure_profiles_appearance' );
	add_settings_field('pure_profiles_enable_styles', 'Use Default Stylesheet', 'pure_profiles_enable_styles_settings', 'pure_profiles', 'pure_profiles_appearance' );

}

function pure_profiles_connection_section_text() {
	echo '<h3>Connection Details</h3><p>Set the connection details for your Pure installation. </p>';
}

function pure_profiles_parameters_section_text() {
	echo '<h3>Parameters</h3><p>Specify the data you wish to retrieve from Pure. You can list Employee IDs, internal Pure UUIDs, or a mixture of both. 
		Both formats should be in a comma separated list.</p>
		<p>Note: Internal Pure UUIDs can be found in the URLs in the Edinburgh Research Explorer, within the brackets.</p>';
}

function pure_profiles_cron_section_text() {
	echo '<h3>Cron</h3><p>Specify the time that the Wordpress cron should run to update the local cache. You should also set up an actual 
		cron job to trigger the Wordpress cron. For example, if your Wordpress cron is set for 1am, you can set a cron to trigger it every day at 2am:</p>
		<code>0 2 * * * curl http://yoursite.com/ >/dev/null 2>&1</code>';
	echo '<p>Development Mode ignores the cron settings and makes the API request on each page call instead.</p>';
}

function pure_profiles_appearance_section_text() {
	echo '<h3>Appearance</h3><p>To use your own styles, untick the Use Default Stylesheet option, and implement the styles in your theme stylesheet.</p>';
}

function pure_profiles_host_settings() {
	$options = get_option( 'pure_profiles_options' );
	$value = htmlentities ( $options['pure_profiles_host_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = 'Enter hostname';
	}
	echo "<input id='pure_profiles_host_settings' name='pure_profiles_options[pure_profiles_host_settings]' size='50' type='text' value='{$value}' />";
}
function pure_profiles_username_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_username_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = 'Enter username';
	}
	echo "<input id='pure_profiles_username_settings' name='pure_profiles_options[pure_profiles_username_settings]' size='50' type='text' value='{$value}' />";
}
function pure_profiles_password_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_password_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = 'Enter password';
	}
	echo "<input id='pure_profiles_password_settings' name='pure_profiles_options[pure_profiles_password_settings]' size='50' type='password' value='{$value}' />";
}

function pure_profiles_person_ids_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_person_ids_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = '';
	}
	echo "<textarea id='pure_profiles_person_ids_settings' name='pure_profiles_options[pure_profiles_person_ids_settings]' rows='4' cols='50'>{$value}</textarea>";
}
function pure_profiles_person_uuids_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_person_uuids_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = '';
	}
	echo "<textarea id='pure_profiles_person_uuids_settings' name='pure_profiles_options[pure_profiles_person_uuids_settings]' rows='4' cols='50'>{$value}</textarea>";
}
function pure_profiles_cron_basehour_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_cron_basehour_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = '1';
	}
	echo "<select id='pure_profiles_cron_basehour_settings' name='pure_profiles_options[pure_profiles_cron_basehour_settings]'>";
	for ($i=0; $i<24; $i++) {
		$selected = ($value==$i) ?  "selected='selected'": "";
		echo "<option value='{$i}' {$selected}>{$i}</option>";
	}
	echo "</select>";
	
}
function pure_profiles_cron_recurrence_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_cron_recurrence_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = 'daily';
	}
	echo "<select id='pure_profiles_cron_recurrence_settings' name='pure_profiles_options[pure_profiles_cron_recurrence_settings]'>";
	$selected = ($value=='hourly') ? " selected='selected'" : "";
	echo "<option value='hourly' {$selected}>hourly</option>";
	$selected = ($value=='daily') ? " selected='selected'" : "";
	echo "<option value='daily' {$selected}>daily</option>";
	echo "</select>";
}
function pure_profiles_cron_dev_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_cron_dev_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = 'no';
	}
	$checked = ($value=='yes') ? " checked" : "";
	echo "<input id='pure_profiles_cron_dev_settings' name='pure_profiles_options[pure_profiles_cron_dev_settings]' type='checkbox' value='yes' {$checked} />";
}
function pure_profiles_enable_styles_settings() {
	$options = get_option('pure_profiles_options');
	$value = htmlentities ( $options['pure_profiles_enable_styles_settings'], ENT_QUOTES );
	if ( !$value ) {
		$value = 'no';
	}
	$checked = ($value=='yes') ? " checked" : "";
	echo "<input id='pure_profiles_enable_styles_settings' name='pure_profiles_options[pure_profiles_enable_styles_settings]' type='checkbox' value='yes' {$checked} />";
}

function pure_profiles_options_validate($input) {
	$options = get_option( 'pure_profiles_options' );
	$options['pure_profiles_host_settings'] = trim($input['pure_profiles_host_settings']);
	$options['pure_profiles_username_settings'] = trim($input['pure_profiles_username_settings']);
	$options['pure_profiles_password_settings'] = trim($input['pure_profiles_password_settings']);
	$options['pure_profiles_person_ids_settings'] = trim($input['pure_profiles_person_ids_settings']); 
	$options['pure_profiles_person_uuids_settings'] = trim($input['pure_profiles_person_uuids_settings']); 
	$options['pure_profiles_cron_basehour_settings'] = trim($input['pure_profiles_cron_basehour_settings']);	
	$options['pure_profiles_cron_recurrence_settings'] = trim($input['pure_profiles_cron_recurrence_settings']);
	$options['pure_profiles_cron_dev_settings'] = trim($input['pure_profiles_cron_dev_settings']);	
	$options['pure_profiles_enable_styles_settings'] = trim($input['pure_profiles_enable_styles_settings']);		
	return $options;
}